/// <reference path="../../js/MDrivenAngularApp.ts" />
/// <reference path="../../js/StreamingAppViewData.ts" />
/// <reference path="../../js/MDrivenAngularApp.ts" />
/// <reference path="../../js/StreamingAppViewData.ts" />
var test1NamespaceForBall;
(function (test1NamespaceForBall) {
    var colors = ['red', 'green', 'blue', 'black', 'yellow'];
    var Ball = (function () {
        function Ball(balldata) {
            this._balldata = balldata;
        }
        Ball.prototype.Draw = function (canvas, context) {
            context.save();
            context.beginPath();
            context.arc(this._balldata.x, this._balldata.y, this._balldata.radius, 0, 2 * Math.PI);
            context.closePath();
            this._balldata.y += this._balldata.dy;
            this._balldata.x += this._balldata.dx;
            if (this._balldata.y >= canvas.height - this._balldata.radius) {
                this._balldata.y = canvas.height - this._balldata.radius;
                this._balldata.dy = -this._balldata.dy;
            }
            else if (this._balldata.y < 0 + this._balldata.radius) {
                this._balldata.y = 0 + this._balldata.radius;
                this._balldata.dy = -this._balldata.dy;
            }
            if (this._balldata.x >= canvas.width - this._balldata.radius) {
                this._balldata.x = canvas.width - this._balldata.radius;
                this._balldata.dx = -this._balldata.dx;
            }
            else if (this._balldata.x < 0 + this._balldata.radius) {
                this._balldata.x = 0 + this._balldata.radius;
                this._balldata.dx = -this._balldata.dx;
            }
            context.fillStyle = this._balldata.color;
            context.fill();
            context.restore();
        };
        return Ball;
    }());
    var Ballpark = (function () {
        function Ballpark(thecanvas, thescope) {
            this._balls = [];
            this._canvas = thecanvas;
            this._context = this._canvas.getContext('2d');
            this._scope = thescope;
        }
        Ballpark.prototype.CheckBalls = function () {
            if (this._scope['data'] instanceof StreamingApp.VMClassObject) {
                var theRoot = this._scope['data'];
                if (theRoot['Details'].length != this._balls.length) {
                    this._balls.length = 0;
                    for (var i = 0; i < theRoot['Details'].length; i++) {
                        var balldata = theRoot['Details'][i];
                        if (balldata.x == null) {
                            balldata.x = Math.floor((Math.random() * 100) + 1);
                            balldata.y = Math.floor((Math.random() * 100) + 1);
                            balldata.dx = Math.floor((Math.random() * 5) + 1);
                            balldata.dy = Math.floor((Math.random() * 5) + 1);
                        }
                        if (balldata.radius == null) {
                            balldata.color = colors[i % 5];
                            balldata.radius = Math.floor((Math.random() * 20) + 1);
                        }
                        var ball = new Ball(balldata);
                        this._balls.push(ball);
                    }
                }
            }
        };
        Ballpark.prototype.Animate = function () {
            this.CheckBalls();
            this._context.clearRect(0, 0, this._canvas.width, this._canvas.height);
            for (var i = 0; i < this._balls.length; i++) {
                this._balls[i].Draw(this._canvas, this._context);
            }
        };
        return Ballpark;
    }());
    test1NamespaceForBall.Ballpark = Ballpark;
})(test1NamespaceForBall || (test1NamespaceForBall = {}));
//# sourceMappingURL=BouncingBalls.js.map